Attribute VB_Name = "DLLDefinitions"
'
' OPTILOGIC Visual Basic Definition module.
'
' These are the two current protocol types.
' They are currently used as the second parameter to OL_NetworkInit
'
' Protocol Definitions.
'
Global Const OL_IPX = 1             ' IPX protocol
Global Const OL_UDP = 2             ' UDP/IP protocol
Global Const OPTISOCKET = &H983     ' network port address
Global Const OL_MAX_MODULES_PER_NODE = 9
Global Const OL_MAX_NODES_PER_NETWORK = 99
'
' Network Initialization functions.
'
Declare Function OL_NetworkInit Lib "OPTILOGICPROTOCOL.DLL" (ByVal port As Integer, ByVal protocoltype As Byte, ByVal Timeout As Integer, ByVal retry As Integer) As Integer
Declare Sub OL_NetworkClose Lib "OPTILOGICPROTOCOL.DLL" ()
Declare Sub OL_NetworkTimeout Lib "OPTILOGICPROTOCOL.DLL" (ByVal Timeout As Long)
Declare Function OL_Buffered_UpdateNodes Lib "OPTILOGICPROTOCOL.DLL" (ByRef nodearray As Integer, ByVal arraysize As Long) As Integer
Declare Function OL_QueryNode Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByRef BaseType As Byte, ByRef moduletypes As Byte, ByRef subtypes As Byte, ByRef moduleVersions As Byte, ByRef minversion As Byte, ByRef majversion As Byte) As Integer
Declare Function OL_GetFirst Lib "OPTILOGICPROTOCOL.DLL" (ByRef NODEADDR As Integer, ByRef BaseType As Byte, ByRef moduletypes As Byte, ByRef subtypes As Byte, ByRef moduleVersions As Byte, ByRef minversion As Byte, ByRef majversion As Byte) As Integer
Declare Function OL_GetNext Lib "OPTILOGICPROTOCOL.DLL" (ByRef NODEADDR As Integer, ByRef BaseType As Byte, ByRef moduletypes As Byte, ByRef subtypes As Byte, ByRef moduleVersions As Byte, ByRef minversion As Byte, ByRef majversion As Byte) As Integer
Declare Function OL_NetworkAddIPSearchAddress Lib "OPTILOGICPROTOCOL.DLL" (ByVal strIPAddress As String) As Integer
Declare Function OL_NetworkRemoveIPSearchAddress Lib "OPTILOGICPROTOCOL.DLL" (ByVal strIPAddress As String) As Integer


'
' Error Retrieval functions
'
Declare Function OL_GetLastErrorFile Lib "OPTILOGICPROTOCOL.DLL" () As String
Declare Function OL_GetLastErrorLineNumber Lib "OPTILOGICPROTOCOL.DLL" () As Long
Declare Function OL_GetLastErrorCode Lib "OPTILOGICPROTOCOL.DLL" () As Long
Declare Function OL_GetLastErrorCodeString Lib "OPTILOGICPROTOCOL.DLL" () As String

Declare Function OL_Buffered_GetErrorCode Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer) As Long
Declare Function OL_Buffered_GetErrorLineNumber Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer) As Long
Declare Function OL_Buffered_GetErrorFile Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer) As String
Declare Function OL_Buffered_GetErrorCodeString Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer) As String

'
'  Housekeeping functions
'
Declare Sub OL_NetworkRetryCount Lib "OPTILOGICPROTOCOL.DLL" (ByVal nRetryCount As Integer)
Declare Function OL_IsNetworkInitialized Lib "OPTILOGICPROTOCOL.DLL" () As Integer
Declare Function OL_GetNodeRetryCount Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer) As Long
Declare Function OL_ResetNodeRetryCount Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer) As Integer

'
'   SDS Master module functions
'
Global Const SDSMaster = 120
Declare Function OL_Send_Receive_SDS_Data Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer, ByVal outLength As Byte, ByRef outdata As Byte, ByRef inLength As Byte, ByRef indata As Byte) As Integer
Declare Function OL_Read_Status_Tables Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer, ByRef rtnLength As Byte, ByRef rtnTable As Byte) As Integer
Declare Function OL_Read_SDS_Device Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer, ByVal sendLength As Byte, ByRef sendTable As Byte, ByRef rtnLength As Byte, ByRef rtnTable As Byte) As Integer
Declare Function OL_SDS_Status_Diag Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer, ByVal sendLength As Byte, ByRef sendTable As Byte, ByRef rtnLength As Byte, ByRef rtnTable As Byte) As Integer
Declare Function OL_SDS_Service_Request Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer, ByVal sendLength As Byte, ByRef sendTable As Byte, ByRef rtnLength As Byte, ByRef rtnTable As Byte) As Integer
Declare Function OL_SDS_IO_Server_Config Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer, ByVal sendLength As Byte, ByRef sendTable As Byte, ByRef rtnLength As Byte, ByRef rtnTable As Byte) As Integer
Declare Function OL_SDS_Cancel_Special_Request Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer) As Integer
Declare Function OL_Buffered_Send_Receive_SDS_Data Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer, ByVal outLength As Byte, ByRef outdata As Byte, ByRef inLength As Byte, ByRef indata As Byte) As Integer
Declare Function OL_Buffered_Read_Status_Tables Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer, ByRef rtnLength As Byte, ByRef rtnTable As Byte) As Integer
Declare Function OL_Buffered_Read_SDS_Device Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer, ByVal sendLength As Byte, ByRef sendTable As Byte, ByRef rtnLength As Byte, ByRef rtnTable As Byte) As Integer
Declare Function OL_Buffered_SDS_Status_Diag Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer, ByVal sendLength As Byte, ByRef sendTable As Byte, ByRef rtnLength As Byte, ByRef rtnTable As Byte) As Integer
Declare Function OL_Buffered_SDS_Service_Request Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer, ByVal sendLength As Byte, ByRef sendTable As Byte, ByRef rtnLength As Byte, ByRef rtnTable As Byte) As Integer
Declare Function OL_Buffered_SDS_IO_Server_Config Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer, ByVal sendLength As Byte, ByRef sendTable As Byte, ByRef rtnLength As Byte, ByRef rtnTable As Byte) As Integer
Declare Function OL_Buffered_SDS_Cancel_Special_Request Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer) As Integer

'
'   Analog Input module functions.
'
Global Const FO04AD1 = 17 '4 Channel Analog Input
Global Const OL2408 = 18 '8 Channel Analog Voltage Input
Declare Function OL_ReadAnalogInput Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer, ByVal IOType As Byte, ByRef data As Integer) As Integer
Declare Function OL_Buffered_ReadAnalogInputs Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer, ByRef data As Integer, ByVal IOType As Byte, ByVal numValues As Byte) As Integer

'
'   Analog Output module functions.
'
Global Const OL2304 = 25 '4 Channel Analog Voltage output
Declare Function OL_WriteAnalogOutput Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer, ByVal IOType As Byte, ByRef data As Integer) As Integer
Declare Function OL_ConfigAnalogOutput Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer, ByVal IOType As Byte, ByVal range1 As Byte, ByVal range2 As Byte, ByVal range3 As Byte, ByVal range4 As Byte) As Integer
Declare Function OL_Buffered_WriteAnalogOutput Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer, ByRef data As Integer, ByVal IOType As Byte, ByVal numValues As Byte) As Integer

'
'   Dual Counter/Digital Input functions
'
Global Const OL2252 = 80 'Dual Counter
Declare Function OL_Read_Counter Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer, ByVal ctlFlags As Byte, ByRef countData As Byte, ByRef indata As Byte) As Integer
Declare Function OL_Buffered_Read_Counter Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer, ByVal ctlFlags As Byte, ByRef countData As Byte, ByRef indata As Byte) As Integer
Declare Function OL_Configure_Counter Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer, ByVal ctlFlags As Byte, ByVal dbSet1 As Byte, ByVal dbSet2 As Byte) As Integer
Declare Function OL_Buffered_Configure_Counter Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer, ByVal ctlFlags As Byte, ByVal dbSet1 As Byte, ByVal dbSet2 As Byte) As Integer
'
'   Dual High Speed Counter/Digital Input functions
'
Global Const OL2258 = 82 'Dual High Speed Counter
Declare Function OL_Read_HS_Counter Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer, ByRef countData As Byte, ByRef freqData As Byte, ByRef inStat As Long, ByRef outStat As Long) As Integer
Declare Function OL_Buffered_Read_HS_Counter Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer, ByRef countData As Byte, ByRef freqData As Byte, ByRef inStat As Long, ByRef outStat As Long) As Integer
Declare Function OL_Configure_HS_Counter Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer, ByVal ctlFlags As Byte, ByVal cfgFlags As Byte, ByRef presetVal As Long) As Integer
Declare Function OL_Buffered_Configure_HS_Counter Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer, ByVal ctlFlags As Byte, ByVal cfgFlags As Byte, ByRef presetVal As Long) As Integer
Declare Function OL_HS_SendOutput_Range_Counter Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer, ByVal output As Byte, ByRef minValue As Long, ByRef maxValue As Long) As Integer
Declare Function OL_Buffered_HS_SendOutput_Range_Counter Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer, ByVal output As Byte, ByRef minValue As Long, ByRef maxValue As Long) As Integer

                                                                            
'
'   Digital Input functions
'
'   The following constants should be used for the IOType parameter
Global Const OL2205 = 5 '4 digital input module
Global Const OL2208 = 1 '8 digital input module
Global Const OL2216 = 2 '16 digital input module
Global Const OL2224 = 3 '24 digital input module
Global Const OL2232 = 4 '32 digital input module
Declare Function OL_ReadDigitalInput Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer, ByVal IOType As Byte, ByRef data As Long) As Integer
Declare Function OL_Buffered_ReadDigitalInput Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer, ByVal IOType As Byte, ByRef data As Long) As Integer
Declare Function OL_ReadLatchedDigitalInput Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer, ByVal IOType As Byte, ByRef data As Long) As Integer
Declare Function OL_Buffered_ReadLatchedDigitalInput Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer, ByVal IOType As Byte, ByRef data As Long) As Integer
'
'   Digital Output functions
'
'   The following constants should be used for the IOType parameter
Global Const OL2104 = 8 '4 digital output module
Global Const OL2108 = 9 '8 digital output module
Global Const OL2116 = 10 '16 digital output module
Global Const OL2124 = 11 '24 digital output module
Global Const OL2132 = 12 '32 digital output module
Declare Function OL_WriteDigitalOutput Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer, ByVal IOType As Byte, ByVal data As Long) As Integer
Declare Function OL_Buffered_WriteDigitalOutput Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer, ByVal IOType As Byte, ByVal data As Long) As Integer
Declare Function OL_SetUpDigitalOutputFailSafe Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer, ByVal byModuleType As Byte, ByVal fsType As Byte, ByVal fsPattern As Long, ByVal fsTime As Byte) As Integer
Declare Function OL_ReadDigitalOutput Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer, ByVal IOType As Byte, ByRef data As Long) As Integer
Declare Function OL_Buffered_ReadDigitalOutput Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal SlotNo As Integer, ByVal IOType As Byte, ByRef data As Long) As Integer
'
'   OL3406 functions
'
Declare Function OL_OL3406_StatusControl Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByRef databuffer As Byte, ByRef pbstatus As Byte) As Integer
Declare Function OL_Buffered_OL3406_StatusControl Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByRef databuffer As Byte, ByRef pbstatus As Byte) As Integer
'
'   These constants should be used for the ButtonFlag parameter.
'
Global Const OL3406 = 128
Global Const OL3406_BUTTON_ALL = &H80
Global Const OL3406_BUTTON_OR = &H40
Global Const OL3406_BUTTON_AND = &H20
Declare Function OL_OL3406_ForceButtons Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal ButtonFlags As Byte, ByVal ButtonData As Byte) As Integer
Declare Function OL_OL3406_ConfigurePanel Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal conflags As Byte) As Integer
Declare Function OL_OL3406_ReadPanelConfiguration Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByRef conflags As Byte) As Integer
Declare Function OL_Buffered_OL3406_ForceButtons Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal ButtonFlags As Byte, ByVal ButtonData As Byte) As Integer
Declare Function OL_Buffered_OL3406_ConfigurePanel Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal conflags As Byte) As Integer
Declare Function OL_Buffered_OL3406_ReadPanelConfiguration Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByRef conflags As Byte) As Integer
'
'   3420 Panel
'
Global Const OL3420 = 136
Global Const OL3420_BUTTON_ALL = &H80
Global Const OL3420_BUTTON_OR = &H40
Global Const OL3420_BUTTON_AND = &H20
Declare Function OL_OL3420_StatusRequest Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal LEDState As Byte, ByRef ButtonStatus As Byte) As Integer
Declare Function OL_OL3420_SendTextDisplayMessage Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal line As Byte, ByRef message As Byte) As Integer
Declare Function OL_OL3420_ConfigurePanel Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal buttonstate As Byte) As Integer
Declare Function OL_OL3420_ReadConfiguration Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByRef buttonstate As Byte) As Integer
Declare Function OL_OL3420_ForceButtons Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal ButtonFlags As Byte, ByVal ButtonData As Byte) As Integer
Declare Function OL_Buffered_OL3420_StatusRequest Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal LEDState As Byte, ByRef ButtonStatus As Byte) As Integer
Declare Function OL_Buffered_OL3420_SendTextDisplayMessage Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal line As Byte, ByRef message As Byte) As Integer
Declare Function OL_Buffered_OL3420_ConfigurePanel Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal buttonstate As Byte) As Integer
Declare Function OL_Buffered_OL3420_ReadConfiguration Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByRef buttonstate As Byte) As Integer
Declare Function OL_Buffered_OL3420_ForceButtons Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal ButtonFlags As Byte, ByVal ButtonData As Byte) As Integer
'
'   3440 Panel
'
Global Const OL3440 = 137
Declare Function OL_OL3440_SendTextDisplayMessage Lib "OPTILOGICPROTOCOL.DLL" (ByVal glbNodeId As Integer, ByVal index As Byte, ByRef message As Byte) As Integer
Declare Function OL_Buffered_OL3440_SendTextDisplayMessage Lib "OPTILOGICPROTOCOL.DLL" (ByVal glbNodeId As Integer, ByVal index As Byte, ByRef message As Byte) As Integer
'
'   3850 Panel
'
Global Const OL3850 = 185
'Declare Function OL_OL3850_StatusRequest Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal LEDState As Byte, ByVal ledflash As Byte, ByRef ButtonStatus As Byte, ByRef returndata As Single) As Integer
Declare Function OL_OL3850_StatusRequest Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal LEDState As Byte, ByVal ledflash As Byte, ByRef ButtonStatus As Byte, ByRef returndata As Double) As Integer
Declare Function OL_OL3850_SendTextDisplayMessage Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal line As Byte, ByRef message As Byte) As Integer
Declare Function OL_OL3850_ConfigurePanel Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal buttonstate As Byte) As Integer
Declare Function OL_OL3850_ReadConfiguration Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByRef buttonstate As Byte) As Integer
Declare Function OL_OL3850_ForceButtons Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal ButtonFlags As Byte, ByVal ButtonData As Byte) As Integer
Declare Function OL_OL3850_SendKeypadMessage Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal line As Byte, ByRef message As Byte, ByVal startNum As Double, ByVal decimalPoint As Byte) As Integer
Declare Function OL_OL3850_SendArrowMessage Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal line As Byte, ByRef message As Byte, ByVal startNum As Long, ByVal decimalPoint As Byte, ByVal lowLimit As Long, ByVal highLimit As Long) As Integer

'Declare Function OL_Buffered_OL3850_StatusRequest Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal LEDState As Byte, ByVal ledflash As Byte, ByRef ButtonStatus As Byte, ByRef returndata As Single) As Integer
Declare Function OL_Buffered_OL3850_StatusRequest Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal LEDState As Byte, ByVal ledflash As Byte, ByRef ButtonStatus As Byte, ByRef returndata As Double) As Integer
Declare Function OL_Buffered_OL3850_SendTextDisplayMessage Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal line As Byte, ByRef message As Byte) As Integer
Declare Function OL_Buffered_OL3850_ConfigurePanel Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal buttonstate As Byte) As Integer
Declare Function OL_Buffered_OL3850_ReadConfiguration Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByRef buttonstate As Byte) As Integer
Declare Function OL_Buffered_OL3850_ForceButtons Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal ButtonFlags As Byte, ByVal ButtonData As Byte) As Integer
Declare Function OL_Buffered_OL3850_SendKeypadMessage Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal line As Byte, ByRef message As Byte, ByVal startNum As Double, ByVal decimalPoint As Byte) As Integer
Declare Function OL_Buffered_OL3850_SendArrowMessage Lib "OPTILOGICPROTOCOL.DLL" (ByVal NODEADDR As Integer, ByVal line As Byte, ByRef message As Byte, ByVal startNum As Long, ByVal decimalPoint As Byte, ByVal lowLimit As Long, ByVal highLimit As Long) As Integer
'
'   Serial Port Functions
'
Global Const BaseComm = 0
Global Const OL2602 = &H70
Global Const OL2604 = &H71
Global Const OL_BASE_SERIAL_PORT = &H51
Declare Function OL_ReadSerialData Lib "OPTILOGICPROTOCOL.DLL" (ByVal glbNodeId As Integer, ByVal SlotNo As Integer, ByVal modtype As Byte, ByVal PortNo As Integer, ByRef numbytes As Byte, ByRef flags As Byte, ByRef message As Byte) As Integer
Declare Function OL_WriteSerialData Lib "OPTILOGICPROTOCOL.DLL" (ByVal glbNodeId As Integer, ByVal SlotNo As Integer, ByVal modtype As Byte, ByVal PortNo As Integer, ByVal numbytes As Byte, ByRef message As Byte, ByRef Leftover As Byte) As Integer
Declare Function OL_Buffered_ReadSerialData Lib "OPTILOGICPROTOCOL.DLL" (ByVal glbNodeId As Integer, ByVal SlotNo As Integer, ByVal modtype As Byte, ByVal PortNo As Integer, ByRef numbytes As Byte, ByRef flags As Byte, ByRef message As Byte) As Integer
Declare Function OL_Buffered_WriteSerialData Lib "OPTILOGICPROTOCOL.DLL" (ByVal glbNodeId As Integer, ByVal SlotNo As Integer, ByVal modtype As Byte, ByVal PortNo As Integer, ByVal numbytes As Byte, ByRef message As Byte, ByRef Leftover As Byte) As Integer

Global Const OL_2602_TOP_PORT = 1
Global Const OL_2602_BOTTOM_PORT = 1
Global Const OL_300_BAUD = 1
Global Const OL_1200_BAUD = 2
Global Const OL_2400_BAUD = 3
Global Const OL_4800_BAUD = 4
Global Const OL_9600_BAUD = 5
Global Const OL_19200_BAUD = 6
Global Const OL_38400_BAUD = 7
Global Const OL_7_DATA_BITS = 7
Global Const OL_8_DATA_BITS = 8
Global Const OL_NO_PARITY = 0
Global Const OL_ODD_PARITY = 1
Global Const OL_EVEN_PARITY = 2
Global Const OL_1_STOP_BIT = 1
Global Const OL_2_STOP_BIT = 2
Global Const OL_15_STOP_BIT = 3
Global Const OL_DISABLE_PORT = 0
Global Const OL_ENABLE_PORT = 1
Declare Function OL_ConfigureSerialPort Lib "OPTILOGICPROTOCOL.DLL" (ByVal glbNodeId As Integer, ByVal SlotNo As Integer, ByVal modtype As Byte, ByVal PortNo As Integer, ByVal BaudRate As Integer, ByVal DataBits As Integer, ByVal Parity As Integer, ByVal StopBits As Integer) As Integer
Declare Function OL_Buffered_ConfigureSerialPort Lib "OPTILOGICPROTOCOL.DLL" (ByVal glbNodeId As Integer, ByVal SlotNo As Integer, ByVal modtype As Byte, ByVal PortNo As Integer, ByVal BaudRate As Integer, ByVal DataBits As Integer, ByVal Parity As Integer, ByVal StopBits As Integer) As Integer
'
'   Other functions
'
Declare Function OL_StartBufferedMessage Lib "OPTILOGICPROTOCOL.DLL" ()
Declare Function OL_SendBufferedMessage Lib "OPTILOGICPROTOCOL.DLL" ()

'
'
'   The following are methods for find the module type.
'
Global OL_ModuleTypeIdentification(255) As String
Public Sub InitializeOLModuleTypeIdentification()
    Dim i As Integer
    For i = 0 To 255
        OL_ModuleTypeIdentification(i) = "Unknown Module Type"
    Next i
    OL_ModuleTypeIdentification(0) = "BaseComm"
    OL_ModuleTypeIdentification(1) = "8 Digital Input"
    OL_ModuleTypeIdentification(2) = "16 Digital Input"
    OL_ModuleTypeIdentification(3) = "24 Digital Input"
    OL_ModuleTypeIdentification(4) = "32 Digital Input"
    OL_ModuleTypeIdentification(5) = "4 Digital Input"
    OL_ModuleTypeIdentification(8) = "4 Digital Output"
    OL_ModuleTypeIdentification(9) = "8 Digital Output"
    OL_ModuleTypeIdentification(10) = "16 Digital Output"
    OL_ModuleTypeIdentification(11) = "24 Digital Output"
    OL_ModuleTypeIdentification(12) = "32 Digital Output"
    OL_ModuleTypeIdentification(16) = "2 Analog Input"
    OL_ModuleTypeIdentification(17) = "4 Analog Input"
    OL_ModuleTypeIdentification(18) = "8 Analog Input"
    OL_ModuleTypeIdentification(19) = "16 Analog Input"
    OL_ModuleTypeIdentification(24) = "2 Analog Output"
    OL_ModuleTypeIdentification(25) = "4 Analog Output"
    OL_ModuleTypeIdentification(26) = "8 Analog Output"
    OL_ModuleTypeIdentification(80) = "Dual Pulse Counter"
    OL_ModuleTypeIdentification(82) = "Dual High Speed Pulse Counter"
    OL_ModuleTypeIdentification(112) = "2 Serial Port"
    OL_ModuleTypeIdentification(113) = "4 Serial Port"
    OL_ModuleTypeIdentification(120) = "SDS Master"
    OL_ModuleTypeIdentification(128) = "OL3406"
    OL_ModuleTypeIdentification(132) = "OL3413"
    OL_ModuleTypeIdentification(133) = "OL3414"
    OL_ModuleTypeIdentification(136) = "OL3420"
    OL_ModuleTypeIdentification(137) = "OL3440"
    OL_ModuleTypeIdentification(185) = "OL3850"
    
End Sub
Public Function GetOLModuleTypeIdentification(ModuleType As Byte) As String
    If (ModuleType < 255) Then
        GetOLModuleTypeIdentification = OL_ModuleTypeIdentification(ModuleType)
    End If
End Function

Public Function GetOLModuleSubTypeIdentification(ModuleType As Byte, SubType As Byte) As String
    GetOLModuleSubTypeIdentification = "Unknown"
    If (ModuleType < 255) Then
        Select Case OL_ModuleTypeIdentification(ModuleType)
            Case "BaseComm"
                GetOLModuleSubTypeIdentification = "BaseComm"
            Case "8 Digital Input"
                Select Case SubType
                    Case 1
                        GetOLModuleSubTypeIdentification = "OL2208"
                    Case 2
                        GetOLModuleSubTypeIdentification = "OL2211"
                    Case 3
                        GetOLModuleSubTypeIdentification = "OL2201"
                 End Select
            Case "4 Digital Input"
                Select Case SubType
                    Case 1
                        GetOLModuleSubTypeIdentification = "OL2205"
                 End Select
            Case "16 Digital Input"
            Case "24 Digital Input"
            Case "32 Digital Input"
            
            Case "4 Digital Output"
                Select Case SubType
                    Case 1
                        GetOLModuleSubTypeIdentification = "OL2104"
                 End Select
            Case "8 Digital Output"
                Select Case SubType
                    Case 1
                        GetOLModuleSubTypeIdentification = "OL2108"
                    Case 2
                        GetOLModuleSubTypeIdentification = "OL2109"
                    Case 3
                        GetOLModuleSubTypeIdentification = "OL2111"
                 End Select
            Case "16 Digital Output"
            Case "24 Digital Output"
            Case "32 Digital Output"
            Case "2 Analog Input"
            Case "4 Analog Input"
                GetOLModuleSubTypeIdentification = "FO04AD1"
            Case "8 Analog Input"
                Select Case SubType
                    Case 1
                        GetOLModuleSubTypeIdentification = "OL2408"
                    Case 2
                        GetOLModuleSubTypeIdentification = "OL2418"
                 End Select
                
            Case "16 Analog Input"
                GetOLModuleSubTypeIdentification = "OL2416"
                
            Case "2 Analog Output"
                GetOLModuleSubTypeIdentification = "OL2302"
            Case "4 Analog Output"
                GetOLModuleSubTypeIdentification = "OL2304"
            Case "8 Analog Output"
                GetOLModuleSubTypeIdentification = "OL2308"
            
            Case "Dual Pulse Counter"
                GetOLModuleSubTypeIdentification = "OL2252"
            Case "Dual High Speed Pulse Counter"
                GetOLModuleSubTypeIdentification = "OL2258"
            
            Case "2 Serial Port"
                GetOLModuleSubTypeIdentification = "OL2602"
            Case "4 Serial Port"
            Case "OL3406"
                GetOLModuleSubTypeIdentification = "OL3406"
            Case "OL3413"
                GetOLModuleSubTypeIdentification = "OL3413"
            Case "OL3414"
                GetOLModuleSubTypeIdentification = "OL3414"
            Case "OL3420"
                GetOLModuleSubTypeIdentification = "OL3420"
            Case "OL3440"
                GetOLModuleSubTypeIdentification = "OL3440"
            Case "OL3850"
                GetOLModuleSubTypeIdentification = "OL3850"
            Case "SDS Master"
                GetOLModuleSubTypeIdentification = "SDS Master"
        End Select
    End If
End Function

